(******************************************************************************

______________________________________________________________________________

PDB2TXT                                                   (C) 2009, 2010 Pepak
http://www.pepak.net/e-books/formaty-pdb/                 http://www.pepak.net
______________________________________________________________________________


Copyright (c) 2010, Pepak (http://www.pepak.net)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of Pepak nor the
      names of his contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL PEPAK BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

******************************************************************************)

program pdb2txt;
{$IFDEF FPC}
  {$MODE DELPHI}
{$ENDIF}
{$APPTYPE CONSOLE}

{%File 'pdb2txt.version'}

{$R *.res}

uses
  SysUtils,
  DocFile in 'Lib\PalmDoc\DocFile.pas',
  PalmDatabase in 'Lib\PalmDoc\PalmDatabase.pas',
  uCompatibility in 'Lib\Pepak\uCompatibility.pas',
  uConsoleApp in 'Lib\Pepak\uConsoleApp.pas',
  uStringUtils in 'Lib\Pepak\uStringUtils.pas',
  uPdb2txt in 'uPdb2txt.pas';

procedure Convert(const FileMask: string; Recursive: boolean);
var SR: TSearchRec;
    OK: integer;
    PDB: TDocFile;
    Dir, Mask: string;
    T: TextFile;
begin
  Dir := ExtractFilePath(FileMask);
  OK := FindFirst(FileMask, faAnyFile, SR);
  if OK = 0 then
    try
      repeat
        if not Longbool(SR.Attr and (faDirectory or faVolumeID)) then
          begin
          Write(Dir + SR.Name + '     ');
          try
            PDB := TDocFile.Create(Dir + SR.Name);
            try
              AssignFile(T, Dir + SR.Name + '.txt');
              Rewrite(T);
              try
                Write(T, PDB.GetDocument);
              finally
                CloseFile(T);
                end;
            finally
              PDB.Free;
              end;
            Writeln('OK');
          except
            on E: Exception do
              Writeln(E.ClassName + ': ' + E.Message);
            end;
          end;
        OK := FindNext(SR);
      until OK <> 0;
    finally
      FindClose(SR);
      end;
  if Recursive then
    begin
    OK := FindFirst(Dir + '*.*', faDirectory, SR);
    Mask := ExtractFileName(FileMask);
    try
      while OK = 0 do
        begin
        if (SR.Name <> '.') and (SR.Name <> '..') then
          Convert(Dir + SR.Name + '\' + Mask, Recursive);
        OK := FindNext(SR);
        end;
    finally
      FindClose(SR);
      end;
    end;
end;

var ErrorMsg: string;
begin
  try
    ExitCode := 0;
    ExitCode := ExecuteConsoleApp(TPdb2Txt);
    {$IFNDEF FPC}
      if DebugHook <> 0 then
        begin
        Writeln;
        Write('Press any key to exit.');
        Readln;
        end;
    {$ENDIF}
  except
    on E: Exception do
      begin
      ErrorMsg := Format('Exception %s: %s', [E.ClassName, E.Message]);
      Writeln(ErrorMsg);
      ExitCode := 255;
      end;
    end;
end.
